//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Tecan.Sila2.Interop.Server.ListDataTypeTest
{
    
    
    /// <summary>
    /// Provides commands and properties to set or respectively get SiLA List Data Type values via command parameters or property responses respectively.
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute(true, "test")]
    [Tecan.Sila2.SilaIdentifierAttribute("ListDataTypeTest")]
    [Tecan.Sila2.SilaDisplayNameAttribute("List Data Type Test")]
    public partial interface IListDataTypeTest
    {
        
        /// <summary>
        /// Returns an empty list of String type.
        /// </summary>
        System.Collections.Generic.ICollection<string> EmptyStringList
        {
            get;
        }
        
        /// <summary>
        /// Returns a list with the following string values: 'SiLA 2', 'is', 'great'.
        /// </summary>
        System.Collections.Generic.ICollection<string> StringList
        {
            get;
        }
        
        /// <summary>
        /// Returns a list with the following Integer values: 1, 2, 3.
        /// </summary>
        System.Collections.Generic.ICollection<long> IntegerList
        {
            get;
        }
        
        /// <summary>
        /// Returns a list with 3 structure values, whereas the values of the first element are:
        /// string value = 'SiLA2_Test_String_Value_1'
        /// integer value = 5124
        /// real value = 3.1415926
        /// boolean value = true
        /// binary value (embedded string) = 'Binary_String_Value_1'
        /// date value = 05.08.2022 respective 08/05/2022
        /// time value = 12:34:56
        /// time stamp value = 2022-08-05 12:34:56.
        /// any type value (string) = 'Any_Type_String_Value_1'
        /// For the second and third element:
        /// the last character of the strings changes to '2' respective '3'
        /// the numeric values are incremented by 1
        /// the boolean values becomes false for element 2 and true for element 3
        /// for the date value day, month and year are incremented by 1
        /// for the time value seconds, minutes and hours are incremented by 1
        /// for the time stamp value day, month, year, seconds, minutes and hours are incremented by 1.
        /// </summary>
        System.Collections.Generic.ICollection<TestStructure> StructureList
        {
            get;
        }
        
        /// <summary>
        /// Receives a list of string values and returns a list containing the string values that have been received.
        /// </summary>
        /// <param name="stringList">The list of string values to be returned.</param>
        /// <returns>A list containing the string values that have been received.</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReceivedValues")]
        System.Collections.Generic.ICollection<string> EchoStringList(System.Collections.Generic.ICollection<string> stringList);
        
        /// <summary>
        /// Receives a list of integer values and returns a list containing the integer values that have been received.
        /// </summary>
        /// <param name="integerList">The list of integer values to be returned.</param>
        /// <returns>A list containing the integer values that have been received.</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReceivedValues")]
        System.Collections.Generic.ICollection<long> EchoIntegerList(System.Collections.Generic.ICollection<long> integerList);
        
        /// <summary>
        /// Receives a list of structure values and returns a list containing the structures that have been received.
        /// </summary>
        /// <param name="structureList">The list of structure values to be returned.</param>
        /// <returns>A message containing the content of all structures that have been received.</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReceivedValues")]
        System.Collections.Generic.ICollection<TestStructure> EchoStructureList(System.Collections.Generic.ICollection<TestStructure> structureList);
    }
    
    /// <summary>
    /// An example Structure data type containing all SiLA basic types.
    /// </summary>
    public struct TestStructure
    {
        
        private string _stringTypeValue;
        
        private long _integerTypeValue;
        
        private double _realTypeValue;
        
        private bool _booleanTypeValue;
        
        private System.IO.Stream _binaryTypeValue;
        
        private System.DateTimeOffset _dateTypeValue;
        
        private System.TimeSpan _timeTypeValue;
        
        private System.DateTimeOffset _timestampTypeValue;
        
        private Tecan.Sila2.DynamicClient.DynamicObjectProperty _anyTypeValue;
        
        /// <summary>
        /// Initializes a new instance
        /// </summary>
        public TestStructure(string stringTypeValue, long integerTypeValue, double realTypeValue, bool booleanTypeValue, System.IO.Stream binaryTypeValue, System.DateTimeOffset dateTypeValue, System.TimeSpan timeTypeValue, System.DateTimeOffset timestampTypeValue, Tecan.Sila2.DynamicClient.DynamicObjectProperty anyTypeValue)
        {
            _stringTypeValue = stringTypeValue;
            _integerTypeValue = integerTypeValue;
            _realTypeValue = realTypeValue;
            _booleanTypeValue = booleanTypeValue;
            _binaryTypeValue = binaryTypeValue;
            _dateTypeValue = dateTypeValue;
            _timeTypeValue = timeTypeValue;
            _timestampTypeValue = timestampTypeValue;
            _anyTypeValue = anyTypeValue;
        }
        
        /// <summary>
        /// A value of SiLA data type String.
        /// </summary>
        public string StringTypeValue
        {
            get
            {
                return _stringTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Integer.
        /// </summary>
        public long IntegerTypeValue
        {
            get
            {
                return _integerTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Real.
        /// </summary>
        public double RealTypeValue
        {
            get
            {
                return _realTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Boolean.
        /// </summary>
        public bool BooleanTypeValue
        {
            get
            {
                return _booleanTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Binary.
        /// </summary>
        public System.IO.Stream BinaryTypeValue
        {
            get
            {
                return _binaryTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Date.
        /// </summary>
        public System.DateTimeOffset DateTypeValue
        {
            get
            {
                return _dateTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Time.
        /// </summary>
        public System.TimeSpan TimeTypeValue
        {
            get
            {
                return _timeTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Timestamp.
        /// </summary>
        public System.DateTimeOffset TimestampTypeValue
        {
            get
            {
                return _timestampTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Any.
        /// </summary>
        public Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeValue
        {
            get
            {
                return _anyTypeValue;
            }
        }
    }
}
